package com.fossgalaxy.games.ggj2017;

import com.fossgalaxy.games.rts.GameState;
import com.fossgalaxy.games.rts.ui.UIModel;

import javax.swing.*;
import java.awt.*;

public class ResourceBar extends JComponent {
    private String[] RESOURCE_NAMES = {"metal", "gold"};

    private UIModel model;
    private int playerID;

    public ResourceBar(UIModel model, int playerID) {
        this.setPreferredSize(new Dimension(800, 20));
        this.model = model;
        this.playerID = playerID;
    }

    @Override
    protected void paintComponent(Graphics g) {
        super.paintComponent(g);

        GameState gs = model.getState();

        FontMetrics metrics = g.getFontMetrics();
        int y = metrics.getHeight();

        int startX = 0;

        for (String resource : RESOURCE_NAMES) {
            int val = gs.getResource(playerID, resource);

            String out = String.format("%s: %d", resource, val);
            int thisWidth = metrics.stringWidth(out);

            g.drawString(resource + ": " + val, startX, y);

            startX += thisWidth + 20;
        }

    }


}
