package com.fossgalaxy.games.ggj2017.drones;

import com.fossgalaxy.games.rts.GameState;
import com.fossgalaxy.games.rts.actions.BuildAction;
import com.fossgalaxy.games.rts.entity.Entity;
import com.fossgalaxy.games.rts.entity.EntityType;
import com.fossgalaxy.games.rts.order.BuildOrder;
import com.fossgalaxy.games.rts.order.Order;
import com.fossgalaxy.object.annotations.ObjectDef;
import org.codetome.hexameter.core.api.CubeCoordinate;

import java.awt.*;

public class DroneBuildAction extends BuildAction {

    @ObjectDef("DroneBuild")
    public DroneBuildAction(EntityType type) {
        super(type);
    }

    @Override
    public void renderHints(Graphics2D g, GameState s, Entity actor) {
        if (actor == null || !DroneUtils.rangeHint(g, actor, s)) {
            return;
        }

        super.renderHints(g, s, actor);
    }

    @Override
    public Order generateOrder(CubeCoordinate co, GameState s) {
        return new BuildOrder(type, co);
    }

    @Override
    public boolean isPossible(Entity entity, GameState s, CubeCoordinate co) {
        if (!DroneUtils.isZoneOfControl(s, entity)) {
            return false;
        }

        return super.isPossible(entity, s, co);
    }

}
