package com.fossgalaxy.games.ggj2017.drones;

import com.fossgalaxy.games.rts.GameState;
import com.fossgalaxy.games.rts.actions.UpgradeAction;
import com.fossgalaxy.games.rts.entity.Entity;
import com.fossgalaxy.games.rts.entity.EntityType;
import com.fossgalaxy.object.annotations.ObjectDef;
import org.codetome.hexameter.core.api.CubeCoordinate;

import java.awt.*;

public class DroneUpgradeAction extends UpgradeAction {

    @ObjectDef("DroneUpgrade")
    public DroneUpgradeAction(EntityType from, EntityType to) {
        super(from, to);
    }

    @Override
    public void renderHints(Graphics2D g, GameState s, Entity actor) {
        if (actor == null || !DroneUtils.rangeHint(g, actor, s)) {
            return;
        }

        super.renderHints(g, s, actor);
    }

    @Override
    public boolean isPossible(Entity entity, GameState s, CubeCoordinate co) {
        if (!DroneUtils.isZoneOfControl(s, entity)) {
            return false;
        }

        return super.isPossible(entity, s, co);
    }

}
